'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});

var _commentParser = require('comment-parser');

var _commentParser2 = _interopRequireDefault(_commentParser);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (iterator) {
    return function (context) {
        var checkJsdoc = undefined,
            sourceCode = undefined;

        sourceCode = context.getSourceCode();

        checkJsdoc = function (functionNode) {
            var jsdocNode = undefined,
                jsdoc = undefined;

            jsdocNode = sourceCode.getJSDocComment(functionNode);
            jsdoc = (0, _commentParser2.default)('/*' + jsdocNode.value + '*/')[0] || {};

            iterator(functionNode, jsdocNode, jsdoc, function (message) {
                context.report(jsdocNode, message);
            }, context);
        };

        return {
            ArrowFunctionExpression: checkJsdoc,
            FunctionDeclaration: checkJsdoc,
            FunctionExpression: checkJsdoc
        };
    };
};

module.exports = exports['default'];
//# sourceMappingURL=iterateJsdoc.js.map
